const main = async function main(mountNode) {
	function exists(e) {
		return typeof e !== 'undefined'
	}
	var MKARR_OPEN = 2 << 1;
	var MKARR_CLOSE = 1 << 1;
	function mkArr(start, end, flag) {
		var arr = [], i;
		if (flag & MKARR_OPEN) {
			if (start <= end) {
				for (i = start; i < end; i++) {
					arr.push(i);
				}
			} else {
				for (i = start; i > end; i--) {
					arr.push(i);
				}
			}
		} else if (flag & MKARR_CLOSE) {
			if (start <= end) {
				for (i = start; i <= end; i++) {
					arr.push(i);
				}
			} else {
				for (i = start; i >= end; i--) {
					arr.push(i);
				}
			}
		}
		return arr;
	}
	var state = {} // global parameters
	var scope = {}
	var childrenAnchor
	var lookahead
	var ATTRIBUTES = 1
	var TEXT_NODE = 2
	var ARRAY = 4
	var EXECUTE = 8
	var COMPONENT = 16
	var booleanAttributes = [
		
	]
	var svgTags = [
		
	]
	var rootElements = []
	var imports = {

	}
	var dynamicNodes = {
1: EXECUTE,
2: EXECUTE,
3: EXECUTE,
4: EXECUTE,
6: EXECUTE,
8: EXECUTE,
11: ARRAY,
14: TEXT_NODE,
17: EXECUTE,
18: TEXT_NODE
	}
	var layers = {
		0: createLayer()
	}

	var instructions = {
0: async function (layer) {
	layer.elements[0] = await createNodes([[layer, 5]
], layer.lookahead[0][0])

	insertLayerElements(layer, 0)
},
1: async function (layer) {
				if (!exists(scope['current-page'])) scope['current-page'] = 1;
			},
2: async function (layer) {
				if (!exists(scope['length'])) scope['length'] = 0;
			},
3: async function (layer) {
				if (!exists(scope['on-page'])) scope['on-page'] = 10;
			},
4: async function (layer) {
				if (!exists(scope['url'])) scope['url'] = "";
			},
5: async function (layer) {
	layer.elements[5] = await createNodes([[layer, 7]
,
[layer, 10]
], layer.lookahead[5][0])

	insertLayerElements(layer, 5)
},
6: async function (layer) {
				scope['pages'] = parseInt(scope['length'] / scope['on-page'], 10);
			},
7: async function (layer) {
	layer.elements[7] = await createNodes([], layer.lookahead[7][0])

	insertLayerElements(layer, 7)
},
8: async function (layer) {
				scope['pages'] = scope['pages'] + 1;
			},
10: async function (layer) {
	layer.elements[10] = await createNodes([['div', {"class": "pagination", "data-component": "pagination"}, [
[layer, 11]

], layer, 10, 0]
], layer.lookahead[10][0])

	insertLayerElements(layer, 10)
},
11: async function (layer) {
await handleArray(layer, 11, async function (iteration) {
await forEach(mkArr(1, scope['pages'], MKARR_CLOSE), async function (item, field) {
scope['page-number'] = item

await iteration(field, item)
})
})

},
12: async function (layer) {
	layer.elements[12] = await createNodes([[layer, 13]
,
[layer, 16]
], layer.lookahead[12][0])

	insertLayerElements(layer, 12)
},
13: async function (layer) {
	layer.elements[13] = await createNodes([['span', {"class": "pagination__item pagination__item--active"}, [
[layer, 14]

], layer, 13, 0]
], layer.lookahead[13][0])

	insertLayerElements(layer, 13)
},
14: function (layer) {
				handleTextNode(layer, 14, scope['page-number'])

			},
16: async function (layer) {
	layer.elements[16] = await createNodes([['a', {"class": "pagination__item"}, [
[layer, 18]

], layer, 16, 0]
], layer.lookahead[16][0])

	insertLayerElements(layer, 16)
},
17: async function (layer) {
				applyAttributes(layer.attributes[16][0].element, {
"href": scope['url'] + scope['page-number'] + "/",
"data-item": scope['page-number']
})

			},
18: function (layer) {
				handleTextNode(layer, 18, scope['page-number'])

			}
	}
	var templates = {
0: async function (layer) {
	layer.index = -1
	await handleTemplate(0, layer)
	await handleTemplate(1, layer)
	await handleTemplate(2, layer)
	await handleTemplate(3, layer)
	await handleTemplate(4, layer)
if (scope['length'] > 0) {
	await handleTemplate(5, layer)
	await handleTemplate(6, layer)
if (scope['length'] % scope['on-page'] != 0) {
	await handleTemplate(7, layer)
	await handleTemplate(8, layer)
}
if (scope['pages'] > 1) {
	await handleTemplate(10, layer)
	await handleTemplate(11, layer)
}
}

	handleTail(layer)
},
12: async function (layer) {
	layer.index = -1
	await handleTemplate(12, layer)
if (scope['current-page'] == scope['page-number']) {
	await handleTemplate(13, layer)
	await handleTemplate(14, layer)
}
else {
	await handleTemplate(16, layer)
	await handleTemplate(17, layer)
	await handleTemplate(18, layer)
}

	handleTail(layer)
}
	}
	var avatarTextarea = document.createElement('textarea')
	var avatarDiv = document.createElement('div')
	var copy = Function.prototype.call.bind(Array.prototype.slice)

	function createLayer() {
		return {
			index: 0,
			state: [],
			elements: {},
			lookahead: {},
			anchors: {},
			children: {},
			attributes: {},
			components: {},
			textCache: {}
		}
	}

	async function forEach(data, callback) {
		var field

		for (field in data) {
			if (data.hasOwnProperty(field)) {
				await callback(data[field], field)
			}
		}
	}

	function indexOf(items, item, usedIndexes) {
		var i

		for (i = 0; i < items.length; i++) {
			if (items[i] === item && usedIndexes.indexOf(i) === -1) {
				return i
			}
		}

		return -1
	}
	
	async function handleArray(parentLayer, layerIndex, iterator) {
		var index = 0, layer, preservedIndex, nextSibling, moveElement
		var usedIndexes = []
		var unusedIndexes = []
		var children = createChildren(parentLayer, layerIndex)

		await iterator(async function (field, item) {
			preservedIndex = indexOf(children.items, item, usedIndexes)

			if (preservedIndex === -1) {
				layer = createLayer()

				var anchor = createAnchor(layer, layerIndex + 1)

				if (index < children.items.length) {
					nextSibling = children.layers[index].elements[layerIndex + 1]

					if (!exists(nextSibling)) {
						nextSibling = children.layers[index].anchors[layerIndex + 1]
					} else if (nextSibling instanceof Array) {
						nextSibling = nextSibling[0]
					}

					insertBefore(nextSibling.parentNode, anchor, nextSibling)
				} else {
					nextSibling = parentLayer.anchors[layerIndex]
					insertBefore(nextSibling.parentNode, anchor, nextSibling)
				}

				children.layers.splice(index, 0, layer)
				children.items.splice(index, 0, item)
				usedIndexes.push(index)
				layer.lookahead[layerIndex + 1] = { 0: parentLayer.lookahead[layerIndex][0] }

				await templates[layerIndex + 1](layer)
			} else {
				if (preservedIndex !== index) {
					nextSibling = children.layers[index].anchors[layerIndex + 1]
					moveElement = children.layers[preservedIndex].anchors[layerIndex + 1]
					insertBefore(nextSibling.parentNode, moveElement, nextSibling)

					moveElement = children.layers[preservedIndex].elements[layerIndex + 1]

					if (exists(moveElement)) {
						moveElement.forEach(function (element) { insertBefore(nextSibling.parentNode, element, nextSibling) })
					}

					children.items.splice(index, 0, children.items.splice(preservedIndex, 1)[0])
					children.layers.splice(index, 0, children.layers.splice(preservedIndex, 1)[0])
				}

				usedIndexes.push(index)
				await templates[layerIndex + 1](children.layers[index])
			}

			index++
		})

		usedIndexes.sort(function (a, b) { return a - b })

		for (index = 0; index < usedIndexes.length; index++) {
			if (usedIndexes[index] !== index) {
				usedIndexes.splice(index, 0, index)
				unusedIndexes.push(index)
			}
		}

		for (; index < children.items.length; index++) {
			unusedIndexes.push(index)
		}

		for (index = unusedIndexes.length - 1; index >= 0; index--) {
			removeArrayLayer(children.layers[unusedIndexes[index]])
			children.layers.splice(unusedIndexes[index], 1)
			children.items.splice(unusedIndexes[index], 1)
		}
	}

	function removeArrayLayer(layer) {
		forEach(layer.children, function (children, childrenIndex) {
			forEach(children.layers, function (layer) {
				removeArrayLayer(layer)
			})
		})
		forEach(layer.anchors, removeElement)
		forEach(layer.elements, function (element, elementIndex) {
			remove(dynamicNodes[layer.state[layer.index]], layer, elementIndex)
		})
	}

	function createChildren(layer, index) {
		if (!exists(layer.children[index])) {
			layer.children[index] = {
				layers: [],
				items: []
			}
		}

		return layer.children[index]
	}

	function findLookaheadNode(lookahead, child) {
		var index
		var lookaheadNode
		var childType = typeof child === 'string'
			? 3
			: child.length == 2
				? 8
				: 1

		for (index = 0; index < lookahead.length; index++) {
			lookaheadNode = lookahead[index]

			if (lookaheadNode.nodeType !== 1 && lookaheadNode.nodeType !== 3) {
				lookahead.splice(index, 1)
				index--
				continue
			}

			if (
				childType === lookaheadNode.nodeType &&
				(childType !== 1 || lookaheadNode.nodeName.toLowerCase() === child[0])
			) {
				lookahead.splice(index, 1)

				return lookaheadNode
			}
		}

		return null
	}

	async function createNodes(children, lookahead) {
		var nodes = []
		var index
		var child

		for (index = 0; index < children.length; index++) {
			child = children[index]

			if (typeof child === 'string') {
				nodes.push(createTextElement(child, findLookaheadNode(lookahead, child)))
			} else if (child.length == 2 && child[0].nodeType && child[0].nodeType === 8) {
				if (child[1] !== lookahead) {
					Array.prototype.splice.apply(child[1], [0, 0].concat(copy(lookahead)))
				}

				nodes.push(child[0])
			} else if (child.length == 2) {
				nodes.push(createAnchor.apply(null, child))
				child[0].lookahead[child[1]] = { 0: lookahead }
			} else if (child[0] !== '!DOCTYPE') {
				var element = await createElement.apply(null, child.concat([findLookaheadNode(lookahead, child)]))
				nodes.push(element)
			}
		}

		return nodes
	}

	function createElementNS(tagname) {
		if (svgTags.indexOf(tagname) > -1) {
			return document.createElementNS('http://www.w3.org/2000/svg', tagname)
		}

		return document.createElement(tagname)
	}

	async function createElement(nodeType, attributes, children, layer, layerIndex, index, lookaheadNode) {
		var element = lookaheadNode || createElementNS(nodeType)
		var nextSibling
		var nodes

		setAttributes(element, attributes)

		if (!exists(layer.attributes[layerIndex])) {
			layer.attributes[layerIndex] = {}
		}

		layer.attributes[layerIndex][index] = {
			cache: {},
			element: element
		}

		nextSibling = element.firstChild
		nodes = await createNodes(children, layer.lookahead[layerIndex][index + 1] = copy(element.childNodes))
		nodes.forEach(function (child) {
			if (!child.parentNode) {
				if (nextSibling) {
					element.insertBefore(child, nextSibling)
				} else {
					element.appendChild(child)
				}
			} else {
				nextSibling = child.nextSibling
			}
		})

		return element
	}

	function createTextElement(content, lookaheadNode) {
		var value = content

		if (String(content).indexOf('&') !== -1) {
			avatarTextarea.innerHTML = content
			value = avatarTextarea.value
		}

		if (lookaheadNode !== null) {
			lookaheadNode.nodeValue = value

			return lookaheadNode
		}

		return document.createTextNode(value)
	}

	async function createTag(tag, attributes, body, layer, lookahead) {
		var lookaheadNode

		lookahead.forEach(function (node, index) {
			if (node.nodeType === 1 && node.nodeName.toLowerCase() === tag && node.innerHTML === body && sameAttributes(attributes, node.attributes)) {
				lookaheadNode = node
				lookahead.splice(index, 1)
			}
		})

		var element = lookaheadNode || createElementNS(tag)

		element.innerHTML = body
		setAttributes(element, attributes)

		return [element]
	}

	function sameAttributes(nextAttributes, currentAttributesMap) {
		var currentAttributes = {}
		var index = 0

		for (; index < currentAttributesMap.length; index++) {
			currentAttributes[currentAttributesMap[index].nodeName] = currentAttributesMap[index].nodeValue
		}

		for (index in nextAttributes) {
			if (!exists(currentAttributes[index]) || currentAttributes[index] !== nextAttributes[index]) {
				return false
			}
		}

		for (index in currentAttributes) {
			if (!exists(nextAttributes[index]) || currentAttributes[index] !== nextAttributes[index]) {
				return false
			}
		}

		return true
	}

	function createAnchor(layer, index) {
		var anchor = document.createComment(index)

		layer.anchors[index] = anchor

		return anchor
	}

	function applyAttributes(element, attributes) {
		forEach(attributes, function (value, attribute) {
			setAttribute(element, attribute, value)
		})
	}

	function setAttributes(element, attributes) {
		var currentAttributes = element.getAttributeNames()
		var usedAttributes = []

		forEach(attributes, function (value, attribute) {
			if (setAttribute(element, attribute, value)) {
				usedAttributes.push(attribute)
			}
		})

		forEach(currentAttributes, function (attribute) {
			if (usedAttributes.indexOf(attribute) === -1 && element.hasAttribute(attribute)) {
				element.removeAttribute(attribute)
			}
		})
	}

	function setAttribute(element, attribute, value) {
		var formattedValue = value === true ? '' : value

		if (booleanAttributes.indexOf(attribute) !== -1) {
			element[attribute] = value

			return true
		}

		if (!exists(value) || value === null || value === false) {
			if (element.hasAttribute(attribute)) {
				element.removeAttribute(attribute)
			} else {
				return true
			}
		} else {
			if (element.getAttribute(attribute) !== formattedValue) {
				element.setAttribute(attribute, formattedValue)
			}

			return true
		}

		return false
	}

	function handleTextNode(layer, index, content) {
		if (exists(layer.textCache[index]) && layer.textCache[index] !== content) {
			remove(TEXT_NODE, layer, index)
		}

		if (!exists(layer.textCache[index]) || layer.textCache[index] !== content) {
			layer.elements[index] = createElementsFromContent(String(content))
			insertLayerElements(layer, index)
			layer.textCache[index] = content
		}
	}

	function createElementsFromContent(content) {
		if (content.indexOf('<') !== -1 || content.indexOf('&') !== -1) {
			avatarDiv.innerHTML = content

			return copy(avatarDiv.childNodes)
		}

		return [createTextElement(content, null)]
	}

	function insertLayerElements(layer, index) {
		var previousSibling = layer.anchors[index]

		layer.elements[index].forEach(function (element) {
			if (!element.parentNode || element.parentNode !== document || previousSibling && element.previousSibling !== previousSibling) {
				insertAfter(element, previousSibling)
			}

			if (element.parentNode && element.parentNode !== document) {
				previousSibling = element
			}
		})
	}

	function insertAfter(element, anchor) {
		var parent = mountNode

		if (anchor) {
			parent = anchor.parentNode
		}

		if (parent === mountNode && rootElements.indexOf(element) === -1) {
			rootElements.push(element)
		}

		if (anchor && anchor.nextSibling) {
			insertBefore(parent, element, anchor.nextSibling)
		} else if (parent !== document || element.nodeType === 8) {
			parent.appendChild(element)
		}
	}

	function insertBefore(parent, element, anchorRef) {
		if (parent !== document || element.nodeType !== 3) parent.insertBefore(element, anchorRef)

		if (parent === mountNode && rootElements.indexOf(element) === -1) {
			rootElements.push(element)
		}
	}

	function removeElement(element) {
		if (element.parentNode !== null) {
			element.parentNode.removeChild(element)
		}
	}

	function remove(type, layer, index) {
		switch (type) {
			case ARRAY: 
				var layerIndex, elementIndex, element 

				forEach(layer.children[index].layers, function (sublayer) {
					forEach(sublayer.elements, function (elements) {
						forEach(elements, removeElement)
					})
				})

				delete layer.children[index]
				break
			case EXECUTE:
				break
			case TEXT_NODE:
				delete layer.textCache[index]
			default:
				if (type === COMPONENT) {
					delete layer.components[index]
					window.$guttStates.delete(layer.elements[index][0])
				}

				layer.elements[index].forEach(removeElement)
				delete layer.elements[index]
		}
	}

	async function handleTemplate(instructionIndex, layer) {
		layer.index++

		if (layer.index >= layer.state.length || instructionIndex < layer.state[layer.index]) {
			layer.state.splice(layer.index, 0, instructionIndex)
			await instructions[instructionIndex](layer)
		} else if (instructionIndex > layer.state[layer.index]) {
			remove(dynamicNodes[layer.state[layer.index]], layer, layer.state[layer.index])
			layer.state.splice(layer.index, 1)
			layer.index--
			handleTemplate(instructionIndex, layer)
		} else if (exists(dynamicNodes[instructionIndex])) {
			instructions[instructionIndex](layer)
		}
	}

	function handleTail(layer) {
		layer.index++

		for (; layer.index < layer.state.length;) {
			remove(dynamicNodes[layer.state[layer.index]], layer, layer.state[layer.index])
			layer.state.splice(layer.index, 1)
		}
	}

	async function removeLookahead(layer) {
		await forEach(layer.lookahead, async function (lookaheads) {
			await forEach(lookaheads, async function (localLookahead) {
				if (lookahead !== localLookahead) {
					await forEach(localLookahead, function (element) {
						if ((lookahead || []).indexOf(element) === -1) removeElement(element)
					})

					localLookahead.splice(0, localLookahead.length)
				}
			})
		})

		await forEach(layer.children, async function (children) {
			await forEach(children.layers, removeLookahead)
		})
	}

	function setState(props) {
		// component setState
		if (arguments.length === 2) {
			scope = Object.assign({}, props)
			state = Object.assign({}, arguments[1])
		// root setState
		} else {
			scope = {}
			state = Object.assign({}, props)
		}

		window.$guttStates.set(rootElements[0], scope)

		if (exists(templates[0]) && exists(layers[0])) {
			templates[0](layers[0])
		}

		return rootElements
	}

	// root mounting
	if (arguments.length <= 2) {
		scope = Object.assign({}, arguments[1])
		state = Object.assign({}, arguments[1])
	// component mounting
	} else if (arguments.length > 2) {
		scope = Object.assign({}, arguments[2])
		state = Object.assign({}, arguments[3])

		layers[0].anchors[0] = arguments[1]
		lookahead = arguments[4]
		childrenAnchor = arguments[5]
	}

	if (!window.$guttStates) {
		window.$guttStates = new Map()
	}

	if (!window.$getState) {
		window.$getState = function (node) {
			return window.$guttStates.get(node)
		}
	}

	if (exists(templates[0]) && exists(layers[0])) {
var componentNames = Object.keys(imports)
		var modules = await Promise.all(Object.values(imports))

		imports = modules.map(function (module) { return module.default })
			.reduce(function (result, module, index) {
				result[componentNames[index]] = module
				return result
			}, {})
				layers[0].lookahead[0] = { 0: lookahead ? lookahead : copy(mountNode.childNodes) }
		await templates[0](layers[0])
		await removeLookahead(layers[0])
	}

	if (rootElements.length) {
		rootElements[0].addEventListener('set-parameter', function (event) {
			var payload = event.detail || {}
			var key

			for (key in payload) {
				if (payload.hasOwnProperty(key)) {
					scope[key] = payload[key]
				}
			}

			window.$guttStates.set(rootElements[0], scope)

			if (exists(templates[0]) && exists(layers[0])) {
				templates[0](layers[0])
			}
		})

		window.$guttStates.set(rootElements[0], scope)
	}

	if (arguments.length <= 2) {
		return setState
	} else {
		return { setState: setState, elements: rootElements }
	}
}
export default main